@echo off
setlocal ENABLEDELAYEDEXPANSION

if "%1" == "" (
:getaccount
	set /p serviceaccount=Please enter desired service account: 
	if "!serviceaccount!" == "" (
		echo You must enter something!
		goto getaccount
	)
	dsquery user -name !serviceaccount!|>nul find /i "!serviceaccount!"
	if errorlevel 1 (
		echo Account not found, please enter a valid account name
		goto getaccount
	)
:gettask
	set /p task=Perform Report or Change? ^(R/C^): 
	if /i not "!task!" == "r" if /i not "!task!" == "c" echo You must enter one of R or C!&goto gettask
:getsvcrestart
	if /i "!task!" == "c" (
		set /p svcrestart=Restart services? ^(Y/N^): 
		if /i not "!svcrestart!" == "y" if /i not "!svcrestart!" == "n" echo You must enter one of Y or N!&goto getsvcrestart
	)
)


for /f %%a in ('pwdgen 24 1') do set newpw=%%a

if /i "!task!" == "c" (
	>nul 2>nul net user !serviceaccount! !newpw! /domain
	if errorlevel 1 (
		echo ERROR - Could not change the account password, exiting.
		goto end
	) else	echo Service account password changed successfully.
)
echo.
echo Checking servers....
echo.

for /f "skip=1" %%a in ('dsquery * -limit 10000 -filter "(&(objectClass=computer)(operatingSystem=Windows Server*))" -attr name') do (
	for /f "tokens=1,3 delims=\ " %%b in ('wmic /node:%%a service get name^,startname^|find /i "!serviceaccount!"') do (
		set servicename=%%b
		if /i "!task!" == "c" (
			echo Account !serviceaccount! runs service !servicename! on %%a - setting password
			wmic /node:%%a service "!servicename!" call Change StartPassword=!newpw! |>nul find /i "ReturnValue = 0"
			if not errorlevel 1 (
				echo %%a - Service startup properties changed successfully
			) else echo %%a - ERROR! - Service startup properties failed
			if /i "!svcrestart!" == "y" (
				echo Restarting service
				2>nul wmic /node:%%a service "!servicename!" call StopService |>nul find /i "ReturnValue = 0"
				if errorlevel 1 echo WARNING - Service did not stop correctly or was already stopped, please check server.
				sleep 5
				2>nul wmic /node:%%a service "!servicename!" call StartService |>nul find /i "ReturnValue = 0"
				if errorlevel 1 echo WARNING - Service did not start correctly, please check server.
			)
			echo.
		) else echo Account !serviceaccount! runs service !servicename! on %%a
	)
)
echo.
echo Done.

:end